chiark / gitweb /
fix todos, all NOTES now in code
[dgit.git] / dgit
diff --git a/dgit b/dgit
index 3cd3c8649e2cb9cfc745732138f0aab095eb27c6..db65aaac454a447c17365712eaa44089fccd652a 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -26,31 +26,35 @@ use Dpkg::Control::Hash;
 use File::Path;
 use POSIX;
 
-open DEBUG, ">&STDERR" or die $!;
-
 our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
 our $suite = 'sid';
 our $package;
 
 our $sign = 1;
 our $dryrun = 0;
+our $changesfile;
 
 our $aliothname = 'iwj@git.debian.org';
-our $aliothpath = '/git/dgit-test';
+our $aliothpath = '/git/dgit-repos';
 our $alioth_git = "git+ssh://$aliothname/$aliothpath";
 our $alioth_sshtestbodge = [$aliothname,$aliothpath];
 
+our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
+
 our (@git) = qw(git);
-our (@dget_opts);
-our (@git_tag_opts);
-our (@gpg) = qw(gpg);
+our (@dget) = qw(dget);
+our (@dput) = qw(dput);
+our (@debsign) = qw(debsign);
+our $keyid;
+
+open DEBUG, ">/dev/null" or die $!;
 
-our %opts_opt_map = ('d' => \@dget_opts,
-                    't' => \@git_tag_opts,
-                    'g' => \@gpg);
+our %opts_opt_map = ('dget' => \@dget,
+                    'dput' => \@dput,
+                    'debsign' => \@debsign);
 
 our $remotename = 'dgit';
-our $ourdscfield = 'Vcs-git-master';
+our $ourdscfield = 'Vcs-Git-Master';
 our $branchprefix = 'dgit';
 
 sub uploadbranch () { return "$branchprefix/$suite"; }
@@ -65,7 +69,7 @@ sub url_get {
        $ua = LWP::UserAgent->new();
        $ua->env_proxy;
     }
-    print DEBUG "fetching @_...\n";
+    print "fetching @_...\n";
     my $r = $ua->get(@_) or die $!;
     die "$_[0]: ".$r->status_line."; failed.\n" unless $r->is_success;
     return $r->decoded_content();
@@ -73,12 +77,30 @@ sub url_get {
 
 our ($dscdata,$dscurl,$dsc);
 
+sub printcmd {
+    my $fh = shift @_;
+    my $intro = shift @_;
+    print $fh $intro or die $!;
+    local $_;
+    foreach my $a (@_) {
+       $_ = $a;
+       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
+           print $fh " '$_'" or die $!;
+       } else {
+           print $fh " $_" or die $!;
+       }
+    }
+    print $fh "\n" or die $!;
+}
+
 sub runcmd {
+    printcmd(\*DEBUG,"+",@_);
     $!=0; $?=0;
     die "@_ $! $?" if system @_;
 }
 
 sub cmdoutput_errok {
+    printcmd(\*DEBUG,"|",@_);
     open P, "-|", @_ or die $!;
     my $d;
     $!=0; $?=0;
@@ -96,17 +118,7 @@ sub cmdoutput {
 }
 
 sub dryrun_report {
-    print "#" or die $!;
-    local $_;
-    foreach my $a (@_) {
-       $_ = $a;
-       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
-           print " '$_'" or die $!;
-       } else {
-           print " $_" or die $!;
-       }
-    }
-    print "\n" or die $!;
+    printcmd(\*STDOUT,"#",@_);
 }
 
 sub runcmd_ordryrun {
@@ -132,42 +144,56 @@ sub parsechangelog {
     return $c;
 }
 
-sub get_archive_dsc () {
-    my $rmad = cmdoutput qw(rmadison -asource),"-s$suite",$package;
+our $rmad;
+
+sub askmadison () {
+    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite",$package;
     $rmad =~ m/^ \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* /x or die "$rmad $?";
     $1 eq $package or die "$rmad $package ?";
     my $vsn = $2;
-    $3 eq $suite or die "$rmad $suite ?";
+    if ($suite ne $3) {
+       # madison canonicalises for us
+       print "canonical suite name for $suite is $3\n";
+       $suite = $3;
+    }
     $4 eq 'source' or die "$rmad ?";
-    # fixme it does not show us the component ?
+    return $vsn;
+}
+
+sub canonicalise_suite () {
+    askmadison();
+}
+
+sub get_archive_dsc () {
+    my $vsn = askmadison();
+    # fixme madison does not show us the component
     my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
     $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
-#print DEBUG Dumper($pdodata, $&, $dscurl);
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
-#print DEBUG Dumper($dscdata, $dscfh);
+    print DEBUG Dumper($dscdata);
     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
-#print DEBUG Dumper($dsc);
+    print DEBUG Dumper($dsc);
     my $fmt = $dsc->{Format};
-    die "unsupported format $fmt, sorry\n" unless $fmt eq '1.0';
+    die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
 }
 
 sub check_for_git () {
     # returns 0 or 1
     my $cmd= 
        "ssh $alioth_sshtestbodge->[0] '".
-       " set -e; cd $aliothpath;".
+       " set -e; cd $alioth_sshtestbodge->[1];".
        " if test -d $package.git; then echo 1; else echo 0; fi".
        "'";
-    #print DEBUG "$cmd\n";
+    print DEBUG "$cmd\n";
     open P, "$cmd |" or die $!;
     $!=0; $?=0;
     my $r = <P>; close P;
-#print STDERR ">$r<\n";
+    print DEBUG ">$r<\n";
     die "$r $! $?" unless $r =~ m/^[01]$/;
     return $r+0;
 }
@@ -209,7 +235,7 @@ sub dsc_files () {
 
 sub is_orig_file ($) {
     local ($_) = @_;
-    m/\.orig\.tar\.\w+$/;
+    m/\.orig(?:-\w+)?\.tar\.\w+$/;
 }
 
 sub generate_commit_from_dsc () {
@@ -223,7 +249,7 @@ sub generate_commit_from_dsc () {
            or $!==&ENOENT
            or die "$f $!";
     }
-    runcmd qw(dget), @dget_opts, qw(--), $dscurl;
+    runcmd @dget, qw(--), $dscurl;
     foreach my $f (grep { is_orig_file($_) } @files) {
        link $f, "../../../../$f"
            or $!==&EEXIST
@@ -297,12 +323,13 @@ sub ensure_we_have_orig () {
        $origurl .= "/$f";
        die "$f ?" unless $f =~ m/^${package}_/;
        die "$f ?" if $f =~ m#/#;
-       runcmd_ordryrun qw(sh -ec),'cd ..; exec dget -- "$1"','x',$origurl;
+       runcmd_ordryrun qw(sh -ec),'cd ..; exec "$@"','x',
+           @dget,'--',$origurl;
     }
 }
 
 sub rev_parse ($) {
-    return cmdoutput @git, qw(rev-parse --), "$_[0]~0";
+    return cmdoutput @git, qw(rev-parse), "$_[0]~0";
 }
 
 sub is_fast_fwd ($$) {
@@ -320,6 +347,7 @@ sub fetch_from_archive () {
     die $! if $!;
     die $? unless ($?==0 && chomp $upload_hash) 
        or ($?==256 && !length $upload_hash);
+    $upload_hash ||= '';
     my $hash;
     if (defined $dsc_hash) {
        die "missing git history even though dsc has hash"
@@ -418,22 +446,39 @@ sub dopush () {
 #        (uploadbranch());
     $dsc->{$ourdscfield} = rev_parse('HEAD');
     $dsc->save("../$dscfn.tmp") or die $!;
-    rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
-fixme need to sign changes
-    if ($sign) {
-       runcmd_ordryrun @git, qw(tag -s),@git_tag_opts,qw(-m),
-           "Release $dsc->{Version} for $suite [dgit]";
-       my @sig_cmd = (@gpg, qw(--clearsign), "../$dscfn");
-       if (!$dryrun) {
-           unlink "../$dscfn.asc" or $!==&ENOENT or die "$dscfn.asc $!";
-           runcmd @sig_cmd;
-           rename "../$dscfn.asc","../$dscfn" or die "$dscfn $!";
-       } else {
-           dryrun_report @sig_cmd;
-       }
+    if (!$dryrun) {
+       rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
+    } else {
+       print "[new .dsc left in $dscfn.tmp]\n";
+    }
+    if (!$changesfile) {
+       my $pat = "../${package}_$clogp->{Version}_*.changes";
+       my @cs = glob $pat;
+        die "$pat ?" unless @cs==1;
+       ($changesfile) = @cs;
+    }
+    my $tag = debiantag($dsc->{Version});
+    if (!check_for_git()) {
+       runcmd_ordryrun qw(ssh),$alioth_sshtestbodge->[0],
+       "set -e; cd $alioth_sshtestbodge->[1];".
+           " mkdir -p $package.git;".
+           " cd $package.git;".
+           " if ! test -d objects; then git init --bare; fi";
     }
     runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".lref(uploadbranch());
-    runcmd_ordryrun qw(dput),"../$dscfn";
+    if ($sign) {
+       my @tag_cmd = (@git, qw(tag -s -m),
+                      "Release $dsc->{Version} for $suite [dgit]");
+       push @tag_cmd, qw(-u),$keyid if defined $keyid;
+       push @tag_cmd, $tag;
+       runcmd_ordryrun @tag_cmd;
+       my @debsign_cmd = @debsign;
+       push @debsign_cmd, "-k$keyid" if defined $keyid;
+       push @debsign_cmd, $changesfile;
+       runcmd_ordryrun @debsign_cmd;
+    }
+    runcmd_ordryrun @git, qw(push),$remotename,"refs/tags/$tag";
+    runcmd_ordryrun @dput, $changesfile;
 }
 
 sub cmd_clone {
@@ -448,7 +493,7 @@ sub cmd_clone {
 }
 
 sub branchsuite () {
-    my $branch = cmdoutput_errok @git, qw(symbolic-ref);
+    my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
     chomp $branch;
     if ($branch =~ m#^refs/heads/$branchprefix/([^/.]+)$#o) {
        return $1;
@@ -463,9 +508,11 @@ sub fetchpullargs () {
     if (@ARGV==0) {
        $suite = branchsuite();
        $suite ||= $clogp->{Distribution};
+       canonicalise_suite();
        print "fetching from suite $suite\n";
     } elsif (@ARGV==1) {
        ($suite) = @ARGV;
+       canonicalise_suite();
     } else {
        die;
     }
@@ -486,22 +533,39 @@ sub cmd_push {
     $package = $clogp->{Source};
     if (@ARGV==0) {
        $suite = $clogp->{Distribution};
+       canonicalise_suite();
     } else {
        die;
     }
     dopush();
 }
 
+sub cmd_build {
+    my $clogp = parsechangelog();
+    $suite = $clogp->{Distribution};
+    $package = $clogp->{Source};
+    canonicalise_suite();
+    runcmd_ordryrun
+       qw(git-buildpackage -us -uc --git-no-sign-tags),
+            "--git-debian-branch=".uploadbranch(),
+            @ARGV;
+}
+
 sub parseopts () {
+    my $om;
     while (@ARGV) {
-       last unless $ARGV[0];
+       last unless $ARGV[0] =~ m/^-/;
        $_ = shift @ARGV;
        last if m/^--?$/;
        if (m/^--/) {
-           if (m/^--dry-run/) {
+           if (m/^--dry-run$/) {
                $dryrun=1;
-           if (m/^--no-sign/) {
+           } elsif (m/^--no-sign$/) {
                $sign=0;
+           } elsif (m/^--(\w+)=(.*)/s && ($om = $opts_opt_map{$1})) {
+               $om->[0] = $2;
+           } elsif (m/^--(\w+):(.*)/s && ($om = $opts_opt_map{$1})) {
+               push @$om, $2;
            } else {
                die "$_ ?";
            }
@@ -509,15 +573,14 @@ sub parseopts () {
            while (m/^-./s) {
                if (s/^-n/-/) {
                    $dryrun=1;
-               } elsif (s/^-p(.*)//s) {
-                   $gpg[0] = $1;
+               } elsif (s/^-D/-/) {
+                   open DEBUG, ">&STDERR" or die $!;
                } elsif (s/^-c(.*=.*)//s) {
                    push @git, $1;
+               } elsif (s/^-C(.*)//s) {
+                   $changesfile = $1;
                } elsif (s/^-k(.*)//s) {
-                   push @git_tag_opts, '-u', $1;
-                   push @gpg, '-u', $1;
-               } elsif (s/^-:([dtg])(.*)//s) {
-                   push @{ $opts_opt_map{$1} }, $_;
+                   $keyid=$1;
                } else {
                    die "$_ ?";
                }